Attribute VB_Name = "Globals"
'
' Your Momma Loves Drama
' Apache Derby - Off to the Races
' Copyright (c) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
'

' Notes to Users
' Before using this application with Apache Derby, you must catalog the database and the server.
'
' db2 CATALOG TCPIP NODE derby REMOTE localhost SERVER 1527
' db2 CATALOG DATABASE YMLD AT NODE derby AUTHENTICATION SERVER
' db2 catalog system odbc data source ymld
'

Option Explicit

Global rdoYMLD As New rdoConnection                         ' Connection object for database
Global ProdDay(32) As Boolean                               ' Production number for each day in a month
Global ProdPerf(32) As Integer                              '
Global monthDays As Variant                                 ' Days in a month
Global monthDoW As Variant                                  ' Day of week in a month
Global monthNames As Variant                                ' Name of months
Global Selected_Start_Month As Integer                      ' Start month of a production
Global Selected_End_Month As Integer                        ' End month of a production
Global Selected_Production As Integer                       ' Which production did you select
Global Selected_Production_Title As String                  ' Production Title
Global Selected_Production_Day As Integer                   ' Production day
Global Selected_Production_Month As Integer                 ' Production month
Global Selected_Production_Date As String                   ' Full production date
Global Selected_Performance As Integer                      ' Selected performance number
Global Selected_Seat(20) As Integer                         ' 20 seats in the theater
Global Selected_Seat_Price(20) As Integer                   ' 20 seat prices
Global Current_Month As Integer                             ' What is the current month displayed
Global Total_Cost As Integer                                ' Total cost of your seat selection



Sub main()
'
'   Load the number of days per month and the start day of the week for each month (2005 only)
'
    monthDays = Array(0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31)
    monthDoW = Array(0, 6, 2, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4)
    monthNames = Array("", "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December")
    ymldMain.Show
    ymldConnect.Show
    
End Sub

Public Function DoConnect(database As String, userid As String, password As String) As Integer
'
' This function is used to connect to the database using the supplied
' database name, userid and password.  If there is a problem allocating
' any of the environment handles or connecting to the database, a non-zero
' return code is passed back to the program
'
Dim rdoEn As rdoEnvironment                                 ' rdo Environment collection
Dim er As rdoError                                          ' rdo Error environment
Dim MSG As String

DoConnect = -1
database = "YMLD"
Set rdoEn = rdoEnvironments(0)                              ' rdoEnvironments is set by VB by default

On Error GoTo ConnectError                                  ' On connection error, issue an error message
With rdoYMLD                                                ' Using the connection object, connect
    .Connect = "UID=" + userid + ";PWD=" + password + ";DSN=" + database + ";" ' Default Userid and Password
    .CursorDriver = rdUseOdbc                               ' Use ODBC Driver Manager
    .EstablishConnection rdDriverNoPrompt, True             ' Establish a connection
    rdoEn.rdoConnections.Add rdoYMLD                        ' Add the database to the connection collection
End With
rdoErrors.Clear
DoConnect = 0
Exit Function

ConnectError:                                               ' Connection error to the database
MSG = "[Error] " & Err & " - " & Error & vbCr
For Each er In rdoErrors
    MSG = MSG & "[Error] " & er.Description _
        & ":" & er.Number & vbCr
Next er
MsgBox MSG, vbCritical, "YMLD Error"
End Function
Sub getErrMessage()
'
' getErrMessage
'
' When an error occurs, the errmsg field is filled with the current
' error message and displayed by the program
'
Dim er As rdoError                                          ' RDO Error messages are in this object
Dim MSG As String                                           ' Message string to display

MSG = "SQL Error: "                                         ' Set up message
For Each er In rdoErrors                                    ' For each error in the collection
    MSG = MSG & er.Description & ":" & er.Number            ' Get first message and ignore the rest
    Exit For
Next er
MsgBox MSG, , "QBCG - SQL Error"                            ' Message with no reply by the user
End Sub

Function Substitute(StrIn As String, _
                    ParamArray variables() As Variant) As String
                    
'
' Substitute will replace the ? in a string with the variables that
' are passed to it.
'
                
Dim SubValues(20) As String                                 ' Array of string
Dim varcnt As Integer                                       ' Count of variables
Dim curvar As Integer                                       ' Current variable in xmlIn
Dim Remainder As String                                     ' Remainder of string
Dim variable As Variant                                     ' Variable in the list
Dim Replacement As String                                   ' Replacement string
Dim found As Integer                                        ' Location of character
Const varChar = "$"                                         ' Character for variables

Substitute = ""                                             ' Nothing to return yet
varcnt = 0                                                  ' No variables
For Each variable In variables                              ' Get each parameter
    varcnt = varcnt + 1                                     ' Increment variable count
    Select Case VarType(variable)                           ' What is this thing
        Case vbDecimal, vbInteger, vbSingle, vbDouble, vbLong
            SubValues(varcnt) = Trim(Str(variable))         ' Convert to a string
        Case Else
            SubValues(varcnt) = Trim(variable)              ' Otherwise just trim it
    End Select
Next

curvar = 0                                                  ' No variables found yet
Remainder = StrIn                                           ' Set remainder to full string
found = InStr(Remainder, varChar)                           ' Find a variable
Do While (found <> 0)                                       ' While variables
    curvar = curvar + 1                                     ' Which variable number?
    If (curvar > varcnt) Then                               ' Not enough parameters
        Replacement = ""                                    ' No string value
    Else
        Replacement = SubValues(curvar)                     ' Get nth parameter
    End If
    Substitute = Substitute + Left(Remainder, found - 1) + Replacement  ' add to string
    Remainder = Mid(Remainder, found + 1)                   ' Strip remainder
    found = InStr(Remainder, varChar)                       ' Find next variable
Loop

If (Remainder <> "") Then                                   ' Some stuff remaining
    Substitute = Substitute + Remainder
End If

End Function

Sub getProdDates(ProdNo As Integer, prodMonth As Integer)
'
' getProdDates will find all performances for a production on
' a given month
'
Dim rdoQry As New rdoQuery                                  ' SQL Handle for execution
Dim rdoResult As rdoResultset                               ' Result of query
Dim PNo As String                                           ' Performance Information
Dim PDay As String
Dim day_count As Integer
Dim sql As String
Dim i As Integer

On Error GoTo SQLErr
'
sql = "SELECT DAY(PERFORMANCE_DATE) AS DAYMONTH, PERFORMANCE_NO " + _
      "FROM PERFORMANCES P " + _
      "WHERE P.PRODUCTION_NO = $ AND " + _
      "      MONTH(P.PERFORMANCE_DATE) = $ AND " + _
      "      P.PERFORMANCE_SEATS > 0 " + _
      "ORDER BY PRODUCTION_NO"

day_count = 1

With rdoQry
    Set .ActiveConnection = rdoYMLD                         ' Connection
    .sql = Substitute(sql, ProdNo, prodMonth)               ' Find dates
    Set rdoResult = .OpenResultset                          ' get the results?
End With

For i = 1 To 31
    ProdDay(i) = False
    ProdPerf(i) = 0
Next i

While rdoResult.EOF = False                                 ' There is data
    With rdoResult
        PDay = !Daymonth                                    ' Performance Day
        PNo = !PERFORMANCE_NO                               ' Performance Number
    End With
    ProdDay(PDay) = True
    ProdPerf(PDay) = PNo
    rdoResult.MoveNext
    day_count = day_count + 1
Wend
rdoResult.Close                                             ' Close the result set
rdoQry.Close
Exit Sub

SQLErr:
  Call getErrMessage
  Exit Sub

End Sub
Function concatenate(ParamArray variables() As Variant) As String
'
'   Concatenate takes a series of strings (or numbers) and places them together into a string
'   separated by semi-colons.  This is used for passing variables to forms.
'
Const Separator = "^"                                       ' Separator for strings
Dim variable As Variant                                     ' Used for extracting variables

concatenate = ""                                            ' Nothing to return yet
For Each variable In variables                              ' Get each parameter
    Select Case VarType(variable)                           ' What is this thing
        Case vbDecimal, vbInteger, vbSingle, vbDouble, vbLong
            concatenate = concatenate + Trim(Str(variable)) + Separator ' Convert to a string
        Case Else
            concatenate = concatenate + Trim(variable) + Separator      ' Already a string
    End Select
Next

End Function
Sub ParseTag(FormTag As String, ParamArray variables() As Variant)
'
'   ParseTag:
'   Given a string, this will parse the values out into the components listed.
'
Const Separator = "^"                                       ' Separator for strings
Dim variable As Variant                                     ' Used for extracting variables
Dim options As Variant
Dim MaxOptions As Integer                                   ' Maximum number of options
Dim optcount As Integer                                     ' Which option am I on?

options = Split(FormTag, Separator)                         ' Split all of the variables
MaxOptions = UBound(options)                                ' What's the maximum number of options I can set?
optcount = -1

For Each variable In variables                              ' Get each parameter
    optcount = optcount + 1                                 ' Increment number of options
    If (optcount >= MaxOptions) Then                        ' Too many variables and not enough data
        Select Case VarType(variable)                       ' What is this thing
            Case vbDecimal, vbInteger, vbSingle, vbDouble, vbLong
                variables(optcount) = 0
            Case Else
                variables(optcount) = ""
        End Select
    Else
        Select Case VarType(variable)                       ' What is this thing
            Case vbDecimal, vbInteger, vbSingle, vbDouble, vbLong
                variables(optcount) = Val(options(optcount)) ' Convert to a string
            Case Else
                variables(optcount) = Trim(options(optcount)) ' Already a string
        End Select
    End If
Next
End Sub

