VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form ymldTransactions 
   Caption         =   "YMLD Transactions"
   ClientHeight    =   3180
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7545
   LinkTopic       =   "Form1"
   ScaleHeight     =   3180
   ScaleWidth      =   7545
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Exit 
      Height          =   375
      Left            =   120
      Picture         =   "ymldTransactions.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   2640
      Width           =   375
   End
   Begin MSFlexGridLib.MSFlexGrid Transactions 
      Height          =   2055
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   7155
      _ExtentX        =   12621
      _ExtentY        =   3625
      _Version        =   393216
      Rows            =   0
      Cols            =   5
      FixedRows       =   0
      FixedCols       =   0
   End
   Begin VB.Label Label4 
      Caption         =   "Return"
      BeginProperty Font 
         Name            =   "Microsoft Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   540
      TabIndex        =   2
      Top             =   2700
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Select a transaction to refund."
      BeginProperty Font 
         Name            =   "Microsoft Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   7095
   End
End
Attribute VB_Name = "ymldTransactions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' Your Momma Loves Drama
' Apache Derby - Off to the Races
' Copyright (c) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
'
Private Sub Exit_Click()
Unload Me
End Sub

Private Sub Form_Load()
Dim rdoQry As New rdoQuery                                  ' SQL Handle for execution
Dim rdoResult As rdoResultset                               ' Result of query
Dim txNo As Integer
Dim txType As String                                        ' Transaction Information
Dim txDate As String
Dim perfNo As Integer
Dim seatNo As Integer
Dim row_count As Integer
Dim sql As String

On Error GoTo SQLErr
'
' Set the column headings
'

Transactions.AddItem "TX#" + vbTab + "TX Type" + vbTab + "Date" + vbTab + "Perf#" + vbTab + "Seat#"

row_count = 1
sql = "SELECT * FROM TRANSACTIONS WHERE TX_TYPE='PURCHASE'"
            
With rdoQry
    Set .ActiveConnection = rdoYMLD                         ' Connection
    .sql = sql                                              ' Get transactions
    Set rdoResult = .OpenResultset                          ' get the results?
End With

While rdoResult.EOF = False                                 ' There is data
    With rdoResult
        txNo = !TX_NO                                       ' Transaction information
        txType = !TX_TYPE                                   ' No#, Type, Date, Perf, Seat
        txDate = !TX_DATE
        perfNo = !PERFORMANCE_NO
        seatNo = !SEAT_NO
    End With
    Transactions.AddItem Str(txNo) + vbTab + txType + vbTab + txDate + vbTab + Str(perfNo) + vbTab + Str(seatNo)
    rdoResult.MoveNext
    row_count = row_count + 1
Wend
If (row_count > 1) Then Transactions.FixedRows = 1          ' Must have at least 2 rows to fix one row
rdoResult.Close                                             ' Close the result set
rdoQry.Close
Exit Sub

SQLErr:
  Call getErrMessage
  Exit Sub

End Sub

Private Sub Transactions_Click()

Dim rdoUpdate As New rdoQuery                               ' SQL Handle for update
Dim updateSeats As String
Dim updateTransaction As String
Dim insertTransaction As String

Dim rdoQry As New rdoQuery                                  ' SQL Handle for execution
Dim txNo As Integer
Dim txType As String                                        ' Transaction information
Dim txDate As String
Dim perfNo As Integer
Dim seatNo As Integer
Dim row_count As Integer
Dim answer As Integer

On Error GoTo SQLErr

current_row = Transactions.Row
If (current_row) = 0 Then Exit Sub

txNo = CInt(Transactions.TextMatrix(current_row, 0))        ' Get information from the row
txType = Transactions.TextMatrix(current_row, 1)            ' TX#, Type, Date, Perf#, Seat#
txDate = Transactions.TextMatrix(current_row, 2)
perfNo = CInt(Transactions.TextMatrix(current_row, 3))
seatNo = CInt(Transactions.TextMatrix(current_row, 4))

answer = MsgBox("Do you want to undo the reservation for performance " + _
          Str(perfNo) + ", seat " + Str(seatNo) + " on " + txDate + "?", vbOKCancel, "Confirm Refund")

If (answer = vbCancel) Then Exit Sub                        ' You don't want to cancel

updateSeats = _
    "UPDATE SEATS " + _
    "  SET SEAT_AVAILABLE = 1 " + _
    "WHERE  SEAT_NO = ? AND PERFORMANCE_NO = ?"
              
updateTransaction = _
    "UPDATE TRANSACTIONS SET TX_TYPE = 'VOID' " + _
    "WHERE TX_NO = ?"

insertTransaction = _
    "INSERT INTO TRANSACTIONS(Tx_Type,Tx_Date,Performance_No,Seat_No) " + _
    " VALUES ('REFUND',CURRENT_DATE, ?, ?)"
    
              
With rdoUpdate
    Set .ActiveConnection = rdoYMLD                         ' Connection
    .sql = updateSeats                                      ' Update the current seats
    .rdoParameters(0) = seatNo
    .rdoParameters(1) = perfNo
    .Execute
    .sql = updateTransaction                                ' Update transaction information
    .rdoParameters(0) = txNo
    .Execute
    .sql = insertTransaction                                ' Insert new transaction
    .rdoParameters(0) = perfNo
    .rdoParameters(1) = seatNo
End With
rdoUpdate.Close

If (Transactions.Rows <= 2) Then                            ' Make sure you have enough rows to fix one
    Transactions.FixedRows = 0
End If
Transactions.RemoveItem (current_row)                       ' Remove deleted row on screen

Exit Sub

SQLErr:
  Call getErrMessage
  Exit Sub

End Sub
